From ffb7502f311be8a83823790bfcf9e57d8aaf4ccd Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 18:35:59 +0000
Subject: [PATCH 1271/2232] Centralize cargo k/v printing in dependency manager


---

diff --git a/gen/build/src/deps.rs b/gen/build/src/deps.rs
index 57e96c9..6e177c9 100644
--- a/gen/build/src/deps.rs
+++ b/gen/build/src/deps.rs
@@ -8,6 +8,17 @@ pub struct Crate {
     pub include_dir: Option<PathBuf>,
 }
 
+impl Crate {
+    pub fn print_to_cargo(&self) {
+        if let Some(crate_dir) = &self.crate_dir {
+            println!("cargo:CXXBRIDGE_CRATE={}", crate_dir.to_string_lossy());
+        }
+        if let Some(include_dir) = &self.include_dir {
+            println!("cargo:CXXBRIDGE_INCLUDE={}", include_dir.to_string_lossy());
+        }
+    }
+}
+
 pub fn direct_dependencies() -> Vec<Crate> {
     let mut crates: BTreeMap<String, Crate> = BTreeMap::new();
 
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index b684a25..ed820d4 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -180,6 +180,11 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
 
     let crate_dir = make_crate_dir(prj);
     let include_dir = make_include_dir(prj)?;
+    let this_crate = Crate {
+        crate_dir,
+        include_dir: Some(include_dir),
+    };
+    this_crate.print_to_cargo();
 
     let mut build = Build::new();
     build.cpp(true);
@@ -190,13 +195,7 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
     }
 
     let mut crates = deps::direct_dependencies();
-    crates.insert(
-        0,
-        Crate {
-            crate_dir,
-            include_dir: Some(include_dir),
-        },
-    );
+    crates.insert(0, this_crate);
 
     eprintln!("\nCXX include path:");
     for krate in crates {
@@ -219,14 +218,11 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
 
 fn make_crate_dir(prj: &Project) -> Option<PathBuf> {
     if prj.include_prefix.as_os_str().is_empty() {
-        let crate_dir = prj.manifest_dir.clone();
-        println!("cargo:CXXBRIDGE_CRATE={}", crate_dir.to_string_lossy());
-        return Some(crate_dir);
+        return Some(prj.manifest_dir.clone());
     }
     let crate_dir = prj.out_dir.join("cxxbridge").join("crate");
     let link = crate_dir.join(&prj.include_prefix);
     if out::symlink_dir(&prj.manifest_dir, link).is_ok() {
-        println!("cargo:CXXBRIDGE_CRATE={}", crate_dir.to_string_lossy());
         Some(crate_dir)
     } else {
         None
@@ -244,7 +240,6 @@ fn make_include_dir(prj: &Project) -> Result<PathBuf> {
         out::write(shared_cxx_h, gen::include::HEADER.as_bytes())?;
         out::symlink_file(shared_cxx_h, cxx_h)?;
     }
-    println!("cargo:CXXBRIDGE_INCLUDE={}", include_dir.to_string_lossy());
     Ok(include_dir)
 }
 

